
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Room_typesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const room_types = await db.room_types.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        capacity_adults: data.capacity_adults
        ||
        null
            ,
            
        capacity_children: data.capacity_children
        ||
        null
            ,
            
        base_rate: data.base_rate
        ||
        null
            ,
            
        active: data.active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await room_types.setHotel( data.hotel || null, {
            transaction,
        });
        
        await room_types.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.room_types.getTableName(),
                belongsToColumn: 'photos',
                belongsToId: room_types.id,
            },
            data.photos,
            options,
        );
        

        return room_types;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const room_typesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                capacity_adults: item.capacity_adults
            ||
            null
            ,
            
                capacity_children: item.capacity_children
            ||
            null
            ,
            
                base_rate: item.base_rate
            ||
            null
            ,
            
                active: item.active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const room_types = await db.room_types.bulkCreate(room_typesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < room_types.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.room_types.getTableName(),
                    belongsToColumn: 'photos',
                    belongsToId: room_types[i].id,
                },
                data[i].photos,
                options,
            );
        }
        

        return room_types;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const room_types = await db.room_types.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.capacity_adults !== undefined) updatePayload.capacity_adults = data.capacity_adults;
        
        
        if (data.capacity_children !== undefined) updatePayload.capacity_children = data.capacity_children;
        
        
        if (data.base_rate !== undefined) updatePayload.base_rate = data.base_rate;
        
        
        if (data.active !== undefined) updatePayload.active = data.active;
        
        
        updatePayload.updatedById = currentUser.id;

        await room_types.update(updatePayload, {transaction});

        
        
        if (data.hotel !== undefined) {
            await room_types.setHotel(
              
              data.hotel,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await room_types.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.room_types.getTableName(),
                belongsToColumn: 'photos',
                belongsToId: room_types.id,
            },
            data.photos,
            options,
        );
        

        return room_types;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const room_types = await db.room_types.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of room_types) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of room_types) {
                await record.destroy({transaction});
            }
        });


        return room_types;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const room_types = await db.room_types.findByPk(id, options);

        await room_types.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await room_types.destroy({
            transaction
        });

        return room_types;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const room_types = await db.room_types.findOne(
            { where },
            { transaction },
        );

        if (!room_types) {
            return room_types;
        }

        const output = room_types.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        output.rooms_room_type = await room_types.getRooms_room_type({
            transaction
        });
        
        
        
        
        
        output.seasonal_rates_room_type = await room_types.getSeasonal_rates_room_type({
            transaction
        });
        
        
        output.dynamic_pricing_rules_room_type = await room_types.getDynamic_pricing_rules_room_type({
            transaction
        });
        
        
        
        
        output.reservations_room_type = await room_types.getReservations_room_type({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.hotel = await room_types.getHotel({
            transaction
        });
        
        
        output.photos = await room_types.getPhotos({
            transaction
        });
        
        
        output.organizations = await room_types.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.hotels,
        as: 'hotel',
        
        where: filter.hotel ? {
          [Op.or]: [
            { id: { [Op.in]: filter.hotel.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.hotel.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'photos',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'room_types',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'room_types',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.capacity_adultsRange) {
                const [start, end] = filter.capacity_adultsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    capacity_adults: {
                    ...where.capacity_adults,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    capacity_adults: {
                    ...where.capacity_adults,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.capacity_childrenRange) {
                const [start, end] = filter.capacity_childrenRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    capacity_children: {
                    ...where.capacity_children,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    capacity_children: {
                    ...where.capacity_children,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.base_rateRange) {
                const [start, end] = filter.base_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    base_rate: {
                    ...where.base_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    base_rate: {
                    ...where.base_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.active) {
                where = {
                    ...where,
                active: filter.active,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.room_types.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'room_types',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.room_types.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

